import matplotlib
matplotlib.use('Agg')
import matplotlib.pyplot as plt
import numpy as np
from sklearn.metrics import confusion_matrix
import re
import itertools

from ast import literal_eval

from batching_system import label_indices

conf_m = [[0,0,0,0,0,0,0,0,0,0,0],
          [0,0,0,0,0,0,0,0,0,0,0],
          [0,0,0,0,0,0,0,0,0,0,0],
          [0,0,0,0,0,0,0,0,0,0,0],
          [0,0,0,0,0,0,0,0,0,0,0],
          [0,0,0,0,0,0,0,0,0,0,0],
          [0,0,0,0,0,0,0,0,0,0,0],
          [0,0,0,0,0,0,0,0,0,0,0],
          [0,0,0,0,0,0,0,0,0,0,0],
          [0,0,0,0,0,0,0,0,0,0,0],
          [0,0,0,0,0,0,0,0,0,0,0]]
conf_m = np.array(conf_m)

avg = {'ensemble_essay': 0,
       'ensemble_fusion': 0,
       'mlp_essay': 0,
       'mlp_fusion': 0}
for i in range(10):
    cross_valid = './savedModels/cross_valid/{}'.format(i)
    with open('{}/svm_metaclassifier_charwordpos/accuracy.txt'.format(cross_valid), 'r') as infile:
        avg['ensemble_essay'] += float(infile.readline())
    with open('{}/svm_metaclassifier_charwordposivector/accuracy.txt'.format(cross_valid), 'r') as infile:
        avg['ensemble_fusion'] += float(infile.readline())
    with open('{}/svm_metaclassifier_charwordposivector/confusion.txt'.format(cross_valid), 'r') as infile:
        temp_list = infile.readlines()
        temp = ''
        for item in temp_list:
            temp += item
        temp = re.sub('(?<=[\d\]])\s+', ',', temp)
        temp = np.array(literal_eval(temp))
        conf_m = np.add(conf_m, temp)
    with open('{}/multiLayerFCMultiInputcharwordpos/accuracy.txt'.format(cross_valid), 'r') as infile:
        temp = literal_eval(infile.readline())
        avg['mlp_essay'] += temp[-1][1]
    with open('{}/multiLayerFCMultiInputcharwordposivector/accuracy.txt'.format(cross_valid), 'r') as infile:
        temp = literal_eval(infile.readline())
        avg['mlp_fusion'] += temp[-1][1]

for key in avg:
    print('{}: {}'.format(key, avg[key]/10.0)) 

print(conf_m)

plt.imshow(conf_m, interpolation='nearest', cmap=plt.cm.inferno_r)
plt.title('Confusion matrix')
plt.colorbar()
tick_marks = np.arange(11)
plt.xticks(tick_marks, label_indices, rotation=45)
plt.yticks(tick_marks, label_indices)

fmt = 'd'
thresh = conf_m.max() / 2.
for i,j in itertools.product(range(conf_m.shape[0]), range(conf_m.shape[1])):
    plt.text(j, i, format(conf_m[i,j], fmt), horizontalalignment='center', color='white' if conf_m[i,j] > thresh else 'black')

plt.ylabel('True label')
plt.xlabel('Predicted label')
plt.tight_layout()

plt.savefig('confmat.png')
