from ast import literal_eval
import csv

from batching_system import lang_id

predictions = {}
with open('./savedModels/multiLayerFCSingleInputchar/predictions.txt', 'r') as infile:
    temp = literal_eval(infile.readline())
    predictions['char'] = {temp[0][i]: temp[1][i] for i in range(len(temp[0]))}

with open('./savedModels/multiLayerFCSingleInputword/predictions.txt', 'r') as infile:
    temp = literal_eval(infile.readline())
    predictions['word'] = {temp[0][i]: temp[1][i] for i in range(len(temp[0]))}

with open('./savedModels/multiLayerFCSingleInputpos/predictions.txt', 'r') as infile:
    temp = literal_eval(infile.readline())
    predictions['pos'] = {temp[0][i]: temp[1][i] for i in range(len(temp[0]))}

with open('./savedModels/multiLayerFCSingleInputivector/predictions.txt', 'r') as infile:
    temp = literal_eval(infile.readline())
    predictions['ivector'] = {temp[0][i]: temp[1][i] for i in range(len(temp[0]))}

correct = {}
with open('./nli-shared-task-2017/data/labels/dev/labels.dev.csv', 'r') as infile:
    reader = csv.DictReader(infile)
    for row in reader:
        correct['%s.txt' % row['test_taker_id']] = lang_id[row['L1']]

char = {'word_correct': 0,
        'pos_correct': 0,
        'ivector_correct': 0,
        'word_incorrect': 0,
        'pos_incorrect': 0,
        'ivector_incorrect': 0,
        'correct': 0,
        'incorrect': 0}
word = {'char_correct': 0,
        'pos_correct': 0,
        'ivector_correct': 0,
        'char_incorrect': 0,
        'pos_incorrect': 0,
        'ivector_incorrect': 0,
        'correct': 0,
        'incorrect': 0}
pos = {'char_correct': 0,
       'word_correct': 0,
       'ivector_correct': 0,
       'char_incorrect': 0,
       'word_incorrect': 0,
       'ivector_incorrect': 0,
       'correct': 0,
       'incorrect': 0}
ivector = {'char_correct': 0,
           'word_correct': 0,
           'pos_correct': 0,
           'char_incorrect': 0,
           'word_incorrect': 0,
           'pos_incorrect': 0,
           'correct': 0,
           'incorrect': 0}
for key in correct:
    ans = correct[key]
    if predictions['char'][key] == ans:
        char['correct'] += 1
        if predictions['word'][key] == ans:
            word['char_correct'] += 1
            char['word_correct'] += 1
        if predictions['pos'][key] == ans:
            pos['char_correct'] += 1
            char['pos_correct'] += 1
        if predictions['ivector'][key] == ans:
            ivector['char_correct'] += 1
            char['ivector_correct'] += 1
    else:
        char['incorrect'] += 1
        if predictions['word'][key] != ans:
            word['char_incorrect'] += 1
            char['word_incorrect'] += 1
        if predictions['pos'][key] != ans:
            pos['char_incorrect'] += 1
            char['pos_incorrect'] += 1
        if predictions['ivector'][key] != ans:
            ivector['char_incorrect'] += 1
            char['ivector_incorrect'] += 1
    if predictions['word'][key] == ans:
        word['correct'] += 1
        if predictions['pos'][key] == ans:
            pos['word_correct'] += 1
            word['pos_correct'] += 1
        if predictions['ivector'][key] == ans:
            ivector['word_correct'] += 1
            word['ivector_correct'] += 1
    else:
        word['incorrect'] += 1
        if predictions['pos'][key] != ans:
            pos['word_incorrect'] += 1
            word['pos_incorrect'] += 1
        if predictions['ivector'][key] != ans:
            ivector['word_incorrect'] += 1
            word['ivector_incorrect'] += 1
    if predictions['pos'][key] == ans:
        pos['correct'] += 1
        if predictions['ivector'][key] == ans:
            ivector['pos_correct'] += 1
            pos['ivector_correct'] += 1
    else:
        pos['incorrect'] += 1
        if predictions['ivector'][key] != ans:
            ivector['pos_incorrect'] += 1
            pos['ivector_incorrect'] += 1
    if predictions['ivector'][key] == ans:
        ivector['correct'] += 1
    else:
        ivector['incorrect'] += 1

agreements = [0, 0, 0]
oracle = [0, 0]
new_oracle = [0, 0]

for key in correct:
    temp = [predictions['char'][key], predictions['word'][key], predictions['pos'][key]]
    ans = correct[key]
    if ans == temp[0] or ans == temp[1] or ans == temp[2]:
        oracle[1] += 1
        new_oracle[1] += 1
    elif ans == predictions['ivector'][key]:
        oracle[0] += 1
        new_oracle[1] += 1
    else:
        oracle[0] += 1
        new_oracle[0] += 1
    if temp[1:] == temp[:-1]:
        agreements[2] += 1
    elif temp[0] == temp[1] or temp[0] == temp[2] or temp[1] == temp[2]:
        agreements[1] += 1
    else:
        agreements[0] += 1

print(char)
print(word)
print(pos)
print(ivector)
print(agreements)
print(oracle)
print(new_oracle)
