import matplotlib
matplotlib.use('PS')
import matplotlib.pyplot as plt
from os.path import exists
from ast import literal_eval

def draw():
    lines = []
    for vector_size in [30000, 100000]:
        for layer_size in [50, 250, 1000, 5000, 10000]:
            if exists('./savedModels/layersize/{}/{}'.format(layer_size, vector_size)):
                with open('./savedModels/layersize/{}/{}/accuracy.txt'.format(layer_size, vector_size), 'r') as infile:
                    acc = literal_eval(infile.readline())
                    x = [z[0] for z in acc[:-1]]
                    y = [z[1] for z in acc[:-1]]
                    line, = plt.plot(x, y, label='{}, {}'.format(vector_size, layer_size))
                    lines.append(line)

    plt.xlabel('Epochs')
    plt.ylabel('Training accuracy')

    plt.legend(handles=lines)

    plt.savefig('layertest.png')

draw()
